#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
lora09.py

20160616
"""

import sys
from PyQt4 import Qt, QtGui, QtCore
#from PyQt4.QtGui import *
#from PyQt4.QtCore import *
from ui_lora import Ui_LoraGUI
from freqMng import FreqMangForm , FreqMangDlg
import serial
from time import sleep
from crc16b import calcByte,calcString,hexCRC,checkModbusWithCrc,readHex

removeCRC = 0x00
addCRC = 0x01
CRCatMicroCtrl = 0x02

class LoraGUI(QtGui.QWidget, Ui_LoraGUI):
	def __init__(self, parent=None, f=QtCore.Qt.WindowFlags()):
		QtGui.QWidget.__init__(self, parent, f)
		self.setupUi(self)
		
		if len( sys.argv ) == 2 :
			szPort = sys.argv[1]
			nBauds = 9600
		else :
			if len( sys.argv ) == 3 :
				szPort = sys.argv[1]
				nBauds = int(sys.argv[2])
			else :
				szPort = "/dev/ttyUSB0"
				nBauds = 9600

		port = szPort
		baudrate = nBauds
		szTitle = "%s @%d" % (port,baudrate)	
		self.bConnPort = True
		try: 	
			self.ser = serial.Serial(
				port,
				baudrate,
				timeout=0,
				parity=serial.PARITY_NONE,
				stopbits=serial.STOPBITS_TWO,
				bytesize=serial.EIGHTBITS
			)
		except serial.SerialException as e:
			print szPort, " port is not connected"
			self.close()
			szTitle = "%s is NOT connected" % port
			self.bConnPort = False
			#sys.exit(-1)
		self.setWindowTitle(szTitle)
		self.connect(self.lineEditStr, Qt.SIGNAL("textChanged(QString)"), self.funcStr2Hex)
		self.connect(self.lineEditHex, Qt.SIGNAL("textChanged(QString)"), self.funcHexChanged)
		self.connect(self.radioButtonWithoutCRC, Qt.SIGNAL("toggled(bool)"), self.funcRemoveCRC)
		self.connect(self.radioButtonAddCRC, Qt.SIGNAL("toggled(bool)"), self.funcAddCRC)
		self.connect(self.radioButtonCrcAtMicroCtrl, Qt.SIGNAL("toggled(bool)"), self.funcCRCuC)	
		self.connect(self.radioButtonTx, Qt.SIGNAL("toggled(bool)"), self.funcTx)
		self.connect(self.radioButtonRx, Qt.SIGNAL("clicked(bool)"), self.funcRx)	
		self.connect(self.radioButtonFreq, Qt.SIGNAL("clicked(bool)"), self.funcFreq)	
		self.connect(self.checkBoxRxAesAtUc, Qt.SIGNAL("clicked(bool)"), self.funcRx)	
		self.connect(self.btTxRx, Qt.SIGNAL("clicked()"), self.btTxRxPressed)
		self.temporitzador = QtCore.QTimer()
		self.connect(self.temporitzador, Qt.SIGNAL("timeout()"), self.funcioTemporitzada)
		self.temporitzador.start(100)
		self.byCtrl = removeCRC
		self.checkBoxReadCharString.setCheckState(QtCore.Qt.Checked)

	def funcAddCRC(self,b):
		if b:
			self.byCtrl = addCRC
			if self.radioButtonRx.isChecked():
				self.funcRx(True)

	def funcRemoveCRC(self,b):
		if b:
			self.byCtrl = removeCRC
			if self.radioButtonRx.isChecked():
				self.funcRx(True)
			
	def funcCRCuC(self,b):
		if b:
			self.byCtrl = CRCatMicroCtrl			
			if self.radioButtonRx.isChecked():
				self.funcRx(True)
			
	def funcTx(self,b):
		if b:
			self.btTxRx.setEnabled(True)

	def funcRx(self,b):
		if b:
			self.btTxRx.setEnabled(False)
		if self.checkBoxRxAesAtUc.isChecked():
			st0 = "%02X" % (self.byCtrl	| 0xC0 )
		else:
			st0 = "%02X" % (self.byCtrl	| 0x80 )
		szHtml = "<font color=\"orange\">" + st0 + "</font>"
		self.plainTextEdit.appendHtml(szHtml)
		#st0 = "%02X" % (self.byCtrl | 0x80)	# 1st byte is function mode
		st1 = "%02X" % 0	    			# 2nd byte is payload length
		self.funcSerialWrite(st0 + st1)

	def funcFreq(self,b):
		if b:
			self.btTxRx.setEnabled(True)
			
	def funcHexChanged(self,szHex):
		nSzHex = len(szHex)
		if nSzHex % 2 == 0:
			i = 0
			szNum = ""
			nByteArray = []
			while ( i < nSzHex ):
				szByte = "%c%c" % (str(szHex[i])[0],str(szHex[i+1])[0])
				szNum += szByte
				nByte = int (szByte,16)
				nByteArray.append(nByte);
				i += 2
			hCRC = hexCRC(nByteArray)
			szAddedCRC="%02X%02X"%(hCRC>>8,hCRC&0xFF)
			self.lineEditCRC.setText(szAddedCRC)
			self.lineEditHex.setText(szNum)

	def funcStr2Hex(self,szStr):
		st = ""
		for ch in str(szStr):
			st += "%02X" % ord(ch)					
		self.lineEditHex.setText(st)

	def funcSerialWrite(self,sz):
		nCmpt = 0
		st = ""
		stMB = ""
		for ch in str(sz):
			st += ch
			nCmpt = nCmpt + 1
			if nCmpt == 2:
				nSt = int(str(st),16)
				stMB+="%c"%(nSt)
				nCmpt = 0
				st = ""
		#readHex(stMB)
		#print ""
		if self.bConnPort:
			self.ser.write(stMB)
		self.bConn = 1
		
	def btTxRxPressed(self):
		szHtml = QtCore.QString("")
		if self.radioButtonFreq.isChecked():
			self.freqMangDlg = FreqMangDlg(self)
			self.freqMangDlg.exec_()
			if self.freqMangDlg.result() == 0:
				fFreq,byMSB,byMid,byLSB = self.freqMangDlg.save()
				if fFreq != 0.0:
					#print "Freq: %.3fMHz --> %2X %2X %2X"%(fFreq,byMSB,byMid,byLSB)
					self.byCtrl = 0x10
					nSzHex = 3
				else:
					#print "It is about to read SX1276 frequency"
					self.byCtrl = 0x20
					nSzHex = 0
				st0 = "%02X" % self.byCtrl	# 1st byte is function mode
				st1 = "%02X" % nSzHex	    # 2nd byte is payload length
				if fFreq != 0.0:
					#self.byCtrl = 0x10
					#nSzHex = 3
					#stMB = "10%c%c%c%c"%(int(str(byMSB),16),int(str(byMid),16),int(str(byLSB),16))
					#stMB = "%02X%02X%02X%02X%02X"%(0x10,byMSB,byMid,byLSB)
					szHtml = "<font color=\"orange\">" + "%02X%02X%02X"%(byMSB,byMid,byLSB) + "</font><font color=\"BlueViolet\">  ("+"%.3f"%(fFreq)+ "MHz)</font>"
					stBytes = st0 + st1 + "%02X%02X%02X"%(byMSB,byMid,byLSB)
				else:
					#self.byCtrl = 0x20
					#nSzHex = 0
					#stMB = "%02X" % 0x20		
					stBytes = st0 + st1
					szHtml = ""			
				szHtml = "<font color=\"orange\">" + st0 + "</font><font color=\"red\">" + st1 + "</font>" + szHtml
				self.plainTextEdit.appendHtml(szHtml)
				self.funcSerialWrite(stBytes)
		else:		
			if self.radioButtonWithoutCRC.isChecked():
				self.byCtrl = removeCRC
			if self.radioButtonAddCRC.isChecked():
				self.byCtrl = addCRC
			if self.radioButtonCrcAtMicroCtrl.isChecked():
				self.byCtrl = CRCatMicroCtrl
			if self.lineEditHex.text().length() % 2 == 0:
				if self.checkBoxTxAesAtUc.isChecked():
					self.byCtrl |= 0x08
				else:
					self.byCtrl &= ~0x08												
				nSzHex = self.lineEditHex.text().length() / 2
				#if self.byCtrl == addCRC:
				if self.radioButtonAddCRC.isChecked():
					nSzHex += 2
				st0 = "%02X" % self.byCtrl	# 1st byte is function mode
				st1 = "%02X" % nSzHex	    # 2nd byte is payload length
				szHtml += "<font color=\"orange\">" + st0 + "</font>"
				szHtml += "<font color=\"red\">" + st1 + "</font>"
				szHtml += "<font color=\"orange\">" + self.lineEditHex.text() + "</font>"
				stBytes = st0 + st1 + self.lineEditHex.text()
				if self.byCtrl == addCRC or self.byCtrl == addCRC | 0x08:
					szHtml += "<font color=\"red\">" + self.lineEditCRC.text() + "</font>"
					stBytes += self.lineEditCRC.text()
				self.plainTextEdit.appendHtml(szHtml)
				self.funcSerialWrite(stBytes)

	def calcFreq(self,byMSB,byMID,byLSB):
		byFreq = ord(byMSB)<<16 | ord(byMID)<<8 | ord(byLSB)
		num = (61.035*float(byFreq))/1000000
		return num

	def processa(self,sz,nQ):
		#print "Rebut:\n",sz
		#print "He rebut %d bytes" % nQ
		szHtml = QtCore.QString("<font color=\"blue\">")
		#for i in range(0, len(sz)):
		for i in range(0, nQ+2):
			szHtml += "{:02X}".format(ord(sz[i]))
		szHtml += "</font>"
		if ("{:02X}".format(ord(sz[0])) == "20") and ("{:02X}".format(ord(sz[1])) == "03"):
			szHtml += "<font color=\"BlueViolet\">  ("+"%.3f"%(self.calcFreq(sz[2],sz[3],sz[4]))+ "MHz)</font>"
		else:
			if self.checkBoxReadCharString.isChecked():
				if self.checkBoxRxAesAtUc.isChecked():
					if self.radioButtonRx.isChecked():
						if len > 2:
							szHtml += "<font color=\"red\">  ("+ sz[0] + ": "+ str(ord(sz[3])) +")</red>"
							sz = sz[4:4+ord(sz[3])]
					if self.radioButtonAddCRC.isChecked():
						szHtml += "<font color=\"BlueViolet\">  ("+ sz[:-2] + ")</font>"
					else:
						szHtml += "<font color=\"BlueViolet\">  ("+ sz + ")</font>"		
				else:
					if self.radioButtonRx.isChecked():
						if len > 2:
							szHtml += "<font color=\"red\">  ("+ sz[0] + ": "+ str(ord(sz[1])) +")</red>"
							sz = sz[2:2+ord(sz[2])]
					if self.radioButtonCrcAtMicroCtrl.isChecked() or self.radioButtonAddCRC.isChecked():
						szHtml += "<font color=\"BlueViolet\">  ("+ sz[:-2] + ")</font>"
					else:
						szHtml += "<font color=\"BlueViolet\">  ("+ sz + ")</font>"		
		self.plainTextEdit.appendHtml(szHtml)
			
	def funcioTemporitzada(self):
		if self.bConnPort:
			data = self.ser.read(1)
			n = self.ser.inWaiting()
			if n:
				data = data + self.ser.read(n)
			if len(data):
				self.processa(data,n-1)
	
	def __del__(self):
		if self.bConnPort:
			self.ser.close()

if __name__ == '__main__':

	app = QtGui.QApplication(sys.argv)
	window = LoraGUI()
	window.show()

	sys.exit(app.exec_())
